Hit Testing

Use hitTest function to get a specified hit area in the workbook.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

In SpreadJS, a workbook consist of five hit test areas:

  1. worksheet
  2. sheetTab
  3. horizontalScrollbar
  4. verticalScrollbar
  5. footerCorner

The workbook's hitTest method returns specified hit area from any X and Y coordinates in the workbook.

spread.hitTest(x, y)

The following table shows the workbook’s different hit areas and their sub-areas:

Workbook Area Click Area
worksheet corner, rowHeader, colHeader, viewport
sheetTab prevArrow, nextArrow, sheetName, blank, resize
horizontalScrollbar leftButton, rightButton, thumbButton, trackButton
verticalScrollbar upButton, downButton, thumbButton, trackButton
footerCorner footerCorner
In SpreadJS, a workbook consist of five hit test areas: worksheet sheetTab horizontalScrollbar verticalScrollbar footerCorner The workbook's hitTest method returns specified hit area from any X and Y coordinates in the workbook. The following table shows the workbook’s different hit areas and their sub-areas: Workbook Area Click Area worksheet corner, rowHeader, colHeader, viewport sheetTab prevArrow, nextArrow, sheetName, blank, resize horizontalScrollbar leftButton, rightButton, thumbButton, trackButton verticalScrollbar upButton, downButton, thumbButton, trackButton footerCorner footerCorner
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), {sheetCount: 1}); //remove body margin document.getElementById("ss").parentNode.parentNode.style.margin = "0"; initFunction(spread); }; function initFunction(spread) { var sheet = spread.getActiveSheet(); spread.suspendPaint(); spread.getSheet(0).name("hitTest"); sheet.setColumnWidth(0, 150); sheet.setText(0, 0, "Click anywhere inside of this workbook."); spread.getHost().addEventListener('click', function(e){ var y = e.pageY - this.offsetTop; var x = e.pageX - this.offsetLeft; var result = spread.hitTest(x, y); var str = getHitAreaName(result); if (result) { document.getElementById("showEventArgs").value="(x: " + result.x.toString() + "," + " y:" + result.y.toString() + ")" + " ; " + str; } }); spread.resumePaint(); } function getHitAreaName(result){ if(result) { var str = ""; var worksheetHitInfo = result.worksheetHitInfo; var tabStripHitInfo = result.tabStripHitInfo; if (worksheetHitInfo) { var hitTestType = worksheetHitInfo.hitTestType; if (hitTestType === 0) { str = 'corner'; } else if (hitTestType === 1) { str = 'colHeader'; } else if (hitTestType === 2) { str = 'rowHeader'; } else { var row = worksheetHitInfo.row; var col = worksheetHitInfo.col; str = 'viewport; ' + '(row: ' + row + ', col: ' + col + ')'; } } else if (tabStripHitInfo) { if (tabStripHitInfo.navButton) { str = tabStripHitInfo.navButton; } else if (tabStripHitInfo.sheetTab) { str = tabStripHitInfo.sheetTab.sheetName; } else if (tabStripHitInfo.resize === true) { str = "resize"; } else { str = "blank"; } } else if (result.horizontalScrollBarHitInfo) { str = result.horizontalScrollBarHitInfo.element; } else if (result.verticalScrollBarHitInfo) { str = result.verticalScrollBarHitInfo.element; } else if (result.footerCornerHitInfo) { str = result.footerCornerHitInfo.element; } } return str; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <div id="settingsDiv"> <br/> <label>This text box shows detailed information about the clicked area in the workbook.</label> <br/> <textarea id="showEventArgs" cols="85" rows="3" style="max-width: 98%"></textarea> </div> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } label { display: block; margin-bottom: 6px; } input { padding: 4px 6px; } input[type=button] { margin-top: 6px; display: block; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

In SpreadJS, a workbook consist of five hit test areas:
worksheet
sheetTab
horizontalScrollbar
verticalScrollbar
footerCorner
The workbook's hitTest method returns specified hit area from any X and Y coordinates in the workbook.
The following table shows the workbook’s different hit areas and their sub-areas:
Workbook Area
Click Area
worksheet
corner, rowHeader, colHeader, viewport
sheetTab
prevArrow, nextArrow, sheetName, blank, resize
horizontalScrollbar
leftButton, rightButton, thumbButton, trackButton
verticalScrollbar
upButton, downButton, thumbButton, trackButton
footerCorner
footerCorner
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
hitTestResult = "";
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
spread.suspendPaint();
let sheet = spread.getActiveSheet();
sheet.name("hitTest");
sheet.setColumnWidth(0, 150);
sheet.setText(0, 0, "Click anywhere inside of this workbook.");
spread.resumePaint();
}
onClick(e: any) {
let y = e.pageY - e.target.offsetTop;
let x = e.pageX - e.target.offsetLeft;
let result = this.spread.hitTest(x, y);
let str = this.getHitAreaName(result);
if (result) {
this.hitTestResult = "(x: " + result.x.toString() + "," + " y:" + result.y.toString() + ")" + " ; " + str;
}
}
getHitAreaName(result: any) {
let str = "";
if (result) {
let worksheetHitInfo = result.worksheetHitInfo;
let tabStripHitInfo = result.tabStripHitInfo;
if (worksheetHitInfo) {
let hitTestType = worksheetHitInfo.hitTestType;
if (hitTestType === 0) {
str = 'corner';
} else if (hitTestType === 1) {
str = 'colHeader';
} else if (hitTestType === 2) {
str = 'rowHeader';
} else {
let row = worksheetHitInfo.row;
let col = worksheetHitInfo.col;
str = 'viewport; ' + '(row: ' + row + ', col: ' + col + ')';
}
} else if (tabStripHitInfo) {
if (tabStripHitInfo.navButton) {
str = tabStripHitInfo.navButton;
} else if (tabStripHitInfo.sheetTab) {
str = tabStripHitInfo.sheetTab.sheetName;
} else if (tabStripHitInfo.resize === true) {
str = "resize";
} else {
str = "blank";
}
} else if (result.horizontalScrollBarHitInfo) {
str = result.horizontalScrollBarHitInfo.element;
} else if (result.verticalScrollBarHitInfo) {
str = result.verticalScrollBarHitInfo.element;
} else if (result.footerCornerHitInfo) {
str = result.footerCornerHitInfo.element;
}
}
return str;
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial" (click)="onClick($event)">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div id="settingsDiv">
<br />
<label>This text box shows detailed information about the clicked area in the workbook.</label>
<br />
<textarea id="showEventArgs" cols="85" rows="3" style="max-width: 98%" [value]="hitTestResult"></textarea>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
label {
display: block;
margin-bottom: 6px;
}
input {
padding: 4px 6px;
}
input[type=button] {
margin-top: 6px;
display: block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
margin: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

In SpreadJS, a workbook consist of five hit test areas:
worksheet
sheetTab
horizontalScrollbar
verticalScrollbar
footerCorner
The workbook's hitTest method returns specified hit area from any X and Y coordinates in the workbook.
The following table shows the workbook’s different hit areas and their sub-areas:
Workbook Area
Click Area
worksheet
corner, rowHeader, colHeader, viewport
sheetTab
prevArrow, nextArrow, sheetName, blank, resize
horizontalScrollbar
leftButton, rightButton, thumbButton, trackButton
verticalScrollbar
upButton, downButton, thumbButton, trackButton
footerCorner
footerCorner
<template>
<div class="sample-tutorial" @click="onClick">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div id="settingsDiv">
<br />
<label>This text box shows detailed information about the clicked area in the workbook.</label>
<br />
<textarea id="showEventArgs" cols="85" rows="3" style="max-width: 98%"
:value="hitTestResult"></textarea>
</div>
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import { ref } from "vue";
import "@mescius/spread-sheets-vue";
let spread = null;
const hitTestResult = ref('');
const initSpread = (s) => {
spread = s;
spread.suspendPaint();
const sheet = spread.getActiveSheet();
sheet.name("hitTest");
sheet.setColumnWidth(0, 150);
sheet.setText(0, 0, "Click anywhere inside of this workbook.");
spread.resumePaint();
}
const onClick = (e) => {
const y = e.pageY - e.target.offsetTop;
const x = e.pageX - e.target.offsetLeft;
const result = spread.hitTest(x, y);
const str = getHitAreaName(result);
if (result) {
hitTestResult.value = "(x: " + result.x.toString() + "," + " y:" + result.y.toString() + ")" + " ; " + str;
}
}
const getHitAreaName = (result) => {
let str = "";
if (result) {
let worksheetHitInfo = result.worksheetHitInfo;
let tabStripHitInfo = result.tabStripHitInfo;
if (worksheetHitInfo) {
let hitTestType = worksheetHitInfo.hitTestType;
if (hitTestType === 0) {
str = 'corner';
} else if (hitTestType === 1) {
str = 'colHeader';
} else if (hitTestType === 2) {
str = 'rowHeader';
} else {
let row = worksheetHitInfo.row;
let col = worksheetHitInfo.col;
str = 'viewport; ' + '(row: ' + row + ', col: ' + col + ')';
}
} else if (tabStripHitInfo) {
if (tabStripHitInfo.navButton) {
str = tabStripHitInfo.navButton;
} else if (tabStripHitInfo.sheetTab) {
str = tabStripHitInfo.sheetTab.sheetName;
} else if (tabStripHitInfo.resize === true) {
str = "resize";
} else {
str = "blank";
}
} else if (result.horizontalScrollBarHitInfo) {
str = result.horizontalScrollBarHitInfo.element;
} else if (result.verticalScrollBarHitInfo) {
str = result.verticalScrollBarHitInfo.element;
} else if (result.footerCornerHitInfo) {
str = result.footerCornerHitInfo.element;
}
}
return str;
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
label {
display: block;
margin-bottom: 6px;
}
input {
padding: 4px 6px;
}
input[type=button] {
margin-top: 6px;
display: block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
margin: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

In SpreadJS, a workbook consist of five hit test areas:
worksheet
sheetTab
horizontalScrollbar
verticalScrollbar
footerCorner
The workbook's hitTest method returns specified hit area from any X and Y coordinates in the workbook.
The following table shows the workbook’s different hit areas and their sub-areas:
Workbook Area
Click Area
worksheet
corner, rowHeader, colHeader, viewport
sheetTab
prevArrow, nextArrow, sheetName, blank, resize
horizontalScrollbar
leftButton, rightButton, thumbButton, trackButton
verticalScrollbar
upButton, downButton, thumbButton, trackButton
footerCorner
footerCorner
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import { useState } from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
export function AppFunc() {
const [spread, setSpread] = useState(null);
const [state, setState] = useState({ hitTestResult: "" });
const initSpread = (spread) => {
setSpread(spread);
spread.suspendPaint();
let sheet = spread.getActiveSheet();
sheet.name("hitTest");
sheet.setColumnWidth(0, 150);
sheet.setText(0, 0, "Click anywhere inside of this workbook.");
spread.resumePaint();
}
const onClick = (e) => {
let y = e.pageY - e.target.offsetTop;
let x = e.pageX - e.target.offsetLeft;
let result = spread.hitTest(x, y);
let str = getHitAreaName(result);
if (result) {
setState({ hitTestResult: "(x: " + result.x.toString() + "," + " y:" + result.y.toString() + ")" + " ; " + str });
}
}
const getHitAreaName = (result) => {
let str = "";
if (result) {
let worksheetHitInfo = result.worksheetHitInfo;
let tabStripHitInfo = result.tabStripHitInfo;
if (worksheetHitInfo) {
let hitTestType = worksheetHitInfo.hitTestType;
if (hitTestType === 0) {
str = 'corner';
} else if (hitTestType === 1) {
str = 'colHeader';
} else if (hitTestType === 2) {
str = 'rowHeader';
} else {
let row = worksheetHitInfo.row;
let col = worksheetHitInfo.col;
str = 'viewport; ' + '(row: ' + row + ', col: ' + col + ')';
}
} else if (tabStripHitInfo) {
if (tabStripHitInfo.navButton) {
str = tabStripHitInfo.navButton;
} else if (tabStripHitInfo.sheetTab) {
str = tabStripHitInfo.sheetTab.sheetName;
} else if (tabStripHitInfo.resize === true) {
str = "resize";
} else {
str = "blank";
}
} else if (result.horizontalScrollBarHitInfo) {
str = result.horizontalScrollBarHitInfo.element;
} else if (result.verticalScrollBarHitInfo) {
str = result.verticalScrollBarHitInfo.element;
} else if (result.footerCornerHitInfo) {
str = result.footerCornerHitInfo.element;
}
}
return str;
}
return <div class="sample-tutorial" onClick={e => onClick(e)}>
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<div className="options-container">
<div id="settingsDiv">
<br />
<label>This text box shows detailed information about the clicked area in the workbook.</label>
<br />
<textarea id="showEventArgs" cols={85} rows={3} style={{ maxWidth: '98%' }} defaultValue={""} value={state.hitTestResult} />
</div>
</div>
</div>;
}
import * as React from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = { hitTestResult: "" };
}
render() {
return <div class="sample-tutorial" onClick={e => this.onClick(e)}>
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<div className="options-container">
<div id="settingsDiv">
<br />
<label>This text box shows detailed information about the clicked area in the workbook.</label>
<br />
<textarea id="showEventArgs" cols={85} rows={3} style={{ maxWidth: '98%' }} defaultValue={""} value={this.state.hitTestResult} />
</div>
</div>
</div>;
}
initSpread(spread) {
this.spread = spread;
spread.suspendPaint();
let sheet = spread.getActiveSheet();
sheet.name("hitTest");
sheet.setColumnWidth(0, 150);
sheet.setText(0, 0, "Click anywhere inside of this workbook.");
spread.resumePaint();
}
onClick(e) {
let y = e.pageY - e.target.offsetTop;
let x = e.pageX - e.target.offsetLeft;
let result = this.spread.hitTest(x, y);
let str = this.getHitAreaName(result);
if (result) {
this.setState({ hitTestResult: "(x: " + result.x.toString() + "," + " y:" + result.y.toString() + ")" + " ; " + str });
}
}
getHitAreaName(result) {
let str = "";
if (result) {
let worksheetHitInfo = result.worksheetHitInfo;
let tabStripHitInfo = result.tabStripHitInfo;
if (worksheetHitInfo) {
let hitTestType = worksheetHitInfo.hitTestType;
if (hitTestType === 0) {
str = 'corner';
} else if (hitTestType === 1) {
str = 'colHeader';
} else if (hitTestType === 2) {
str = 'rowHeader';
} else {
let row = worksheetHitInfo.row;
let col = worksheetHitInfo.col;
str = 'viewport; ' + '(row: ' + row + ', col: ' + col + ')';
}
} else if (tabStripHitInfo) {
if (tabStripHitInfo.navButton) {
str = tabStripHitInfo.navButton;
} else if (tabStripHitInfo.sheetTab) {
str = tabStripHitInfo.sheetTab.sheetName;
} else if (tabStripHitInfo.resize === true) {
str = "resize";
} else {
str = "blank";
}
} else if (result.horizontalScrollBarHitInfo) {
str = result.horizontalScrollBarHitInfo.element;
} else if (result.verticalScrollBarHitInfo) {
str = result.verticalScrollBarHitInfo.element;
} else if (result.footerCornerHitInfo) {
str = result.footerCornerHitInfo.element;
}
}
return str;
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
label {
display: block;
margin-bottom: 6px;
}
input {
padding: 4px 6px;
}
input[type=button] {
margin-top: 6px;
display: block;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
margin: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);